<template lang="pug">
.field.has-addons( ref="input" )
	.control.is-expanded
		input.input( ref="date_from" )
	.control.is-expanded
		input.input( ref="date_to" )
</template>

<script setup>
import dayjs from "dayjs"
import { DateRangePicker } from "vanillajs-datepicker"

import { computed, onMounted, ref, watch } from "vue"
import { useI18n } from "vue-i18n"

const props = defineProps({
	modelValue: Object,
	disabled: {
		type: Array,
		default: []
	}
})
const emit = defineEmits([ "update:modelValue" ])

const input = ref()
const date_from = ref()
const date_to = ref()
const calendar = ref(null)

const data = computed({
	get: () => ({ 
		date_from: props.modelValue?.date_from,
		date_to: props.modelValue?.date_to
	}),
	set: ({ date_from, date_to }) => emit("update:modelValue", { date_from, date_to })
})

const calendarInit = () => {
	if (!calendar.value) {
		calendar.value = new DateRangePicker(input.value, {
			clearBtn: true,
			format: "dd-mm-yyyy",
			todayHighlight: true,
			datesDisabled: props.disabled.map(date => dayjs(date).toDate()),
			inputs: [ date_from.value, date_to.value ]
		})
	} else {
		calendar.value.destroy()
		calendar.value = null
		calendarInit()
	}
}

const setValues = () => {
	let start = props.modelValue?.date_from ? dayjs(props.modelValue.date_from).toDate() : { clear: true }
	let end = props.modelValue?.date_to ? dayjs(props.modelValue.date_to).toDate() : { clear: true }

	calendar.value.setDates(start, end)
}
let i = 0
watch(() => [...props.disabled], () => {
	calendarInit()
	setValues()
})

watch(() => ({ ...props.modelValue }), setValues)
onMounted(() => {
	if (input.value) calendarInit()
	if (props.modelValue) setValues()

	date_from.value.addEventListener("changeDate", ({ detail: { date } }) => {
		let time = dayjs(data.value.date_from || dayjs()).format("HH:m") 
		let hours = time.split(":")[0]
		let minutes = time.split(":")[1]
		
		data.value = { ...data.value, date_from: dayjs(date).set("hour", hours).set("minute", minutes).toDate() }
	})

	date_to.value.addEventListener("changeDate", ({ detail: { date } }) => {
		let time = dayjs(data.value.date_to || dayjs()).format("HH:m")
		let hours = time.split(":")[0]
		let minutes = time.split(":")[1]
		
		data.value = { ...data.value, date_to: dayjs(date).set("hour", hours).set("minute", minutes).toDate() }
		
	})
})
</script>

<style lang="scss">
.input {
	z-index: 1!important;
}
</style>